diff --git a/libpurple/protocols/demo/purpledemoprotocolactions.c b/libpurple/protocols/demo/purpledemoprotocolactions.c
--- a/libpurple/protocols/demo/purpledemoprotocolactions.c
+++ b/libpurple/protocols/demo/purpledemoprotocolactions.c
@@ -367,7 +367,7 @@ purple_demo_protocol_request_wait_activa
 
 static void
 purple_demo_protocol_request_fields_ok_cb(G_GNUC_UNUSED gpointer data,
-                                          PurpleRequestFields *fields)
+                                          PurpleRequestPage *page)
 {
 	PurpleAccount *account = NULL;
 	PurpleRequestField *field = NULL;
@@ -378,30 +378,30 @@ purple_demo_protocol_request_fields_ok_c
 	info = g_string_new(_("Basic group:\n"));
 
 	g_string_append_printf(info, _("\tString: %s\n"),
-	                       purple_request_fields_get_string(fields, "string"));
+	                       purple_request_page_get_string(page, "string"));
 	g_string_append_printf(info, _("\tMultiline string: %s\n"),
-	                       purple_request_fields_get_string(fields,
-	                                                        "multiline-string"));
+	                       purple_request_page_get_string(page,
+	                                                      "multiline-string"));
 	g_string_append_printf(info, _("\tMasked string: %s\n"),
-	                       purple_request_fields_get_string(fields,
-	                                                        "masked-string"));
+	                       purple_request_page_get_string(page,
+	                                                      "masked-string"));
 	g_string_append_printf(info, _("\tAlphanumeric string: %s\n"),
-	                       purple_request_fields_get_string(fields,
-	                                                        "alphanumeric"));
+	                       purple_request_page_get_string(page,
+	                                                      "alphanumeric"));
 	g_string_append_printf(info, _("\tEmail string: %s\n"),
-	                       purple_request_fields_get_string(fields, "email"));
+	                       purple_request_page_get_string(page, "email"));
 	g_string_append_printf(info, _("\tInteger: %d\n"),
-	                       purple_request_fields_get_integer(fields, "int"));
+	                       purple_request_page_get_integer(page, "int"));
 	g_string_append_printf(info, _("\tBoolean: %s\n"),
-	                       purple_request_fields_get_bool(fields, "bool") ?
+	                       purple_request_page_get_bool(page, "bool") ?
 	                       _("TRUE") : _("FALSE"));
 
 	g_string_append(info, _("Multiple-choice group:\n"));
 
-	tmp = (const char *)purple_request_fields_get_choice(fields, "choice");
+	tmp = (const char *)purple_request_page_get_choice(page, "choice");
 	g_string_append_printf(info, _("\tChoice: %s\n"), tmp);
 
-	field = purple_request_fields_get_field(fields, "list");
+	field = purple_request_page_get_field(page, "list");
 	list = purple_request_field_list_get_selected(field);
 	if(list != NULL) {
 		tmp = (const char *)list->data;
@@ -410,7 +410,7 @@ purple_demo_protocol_request_fields_ok_c
 	}
 	g_string_append_printf(info, _("\tList: %s\n"), tmp);
 
-	field = purple_request_fields_get_field(fields, "multilist");
+	field = purple_request_page_get_field(page, "multilist");
 	list = purple_request_field_list_get_selected(field);
 	g_string_append(info, _("\tMulti-list: ["));
 	while(list != NULL) {
@@ -423,7 +423,7 @@ purple_demo_protocol_request_fields_ok_c
 
 	g_string_append(info, _("Special group:\n"));
 
-	account = purple_request_fields_get_account(fields, "account");
+	account = purple_request_page_get_account(page, "account");
 	if(PURPLE_IS_ACCOUNT(account)) {
 		tmp = purple_contact_info_get_name_for_display(PURPLE_CONTACT_INFO(account));
 	} else {
@@ -438,7 +438,7 @@ purple_demo_protocol_request_fields_ok_c
 
 static void
 purple_demo_protocol_request_fields_cancel_cb(G_GNUC_UNUSED gpointer data,
-                                              G_GNUC_UNUSED PurpleRequestFields *fields)
+                                              G_GNUC_UNUSED PurpleRequestPage *page)
 {
 	g_message(_("UI cancelled field request"));
 }
@@ -452,7 +452,7 @@ purple_demo_protocol_request_fields_acti
 	const gchar *account_id = NULL;
 	PurpleAccountManager *manager = NULL;
 	PurpleAccount *account = NULL;
-	PurpleRequestFields *fields = NULL;
+	PurpleRequestPage *page = NULL;
 	PurpleRequestGroup *group = NULL;
 	PurpleRequestField *field = NULL;
 	GBytes *icon = NULL;
@@ -470,11 +470,11 @@ purple_demo_protocol_request_fields_acti
 	account = purple_account_manager_find_by_id(manager, account_id);
 	connection = purple_account_get_connection(account);
 
-	fields = purple_request_fields_new();
+	page = purple_request_page_new();
 
 	/* This group will contain basic fields. */
 	group = purple_request_group_new(_("Basic"));
-	purple_request_fields_add_group(fields, group);
+	purple_request_page_add_group(page, group);
 
 	field = purple_request_field_label_new("basic-label",
 	                                       _("This group contains basic fields"));
@@ -512,7 +512,7 @@ purple_demo_protocol_request_fields_acti
 
 	/* This group will contain fields with multiple options. */
 	group = purple_request_group_new(_("Multiple"));
-	purple_request_fields_add_group(fields, group);
+	purple_request_page_add_group(page, group);
 
 	field = purple_request_field_label_new("multiple-label",
 	                                       _("This group contains fields with multiple options"));
@@ -542,7 +542,7 @@ purple_demo_protocol_request_fields_acti
 
 	/* This group will contain specialized fields. */
 	group = purple_request_group_new(_("Special"));
-	purple_request_fields_add_group(fields, group);
+	purple_request_page_add_group(page, group);
 
 	field = purple_request_field_label_new("special-label",
 	                                       _("This group contains specialized fields"));
@@ -562,7 +562,7 @@ purple_demo_protocol_request_fields_acti
 	purple_request_group_add_field(group, field);
 
 	purple_request_fields(connection, _("Request Fields Demo"),
-	                      _("Please fill out these fields…"), NULL, fields,
+	                      _("Please fill out these fields…"), NULL, page,
 	                      _("OK"),
 	                      G_CALLBACK(purple_demo_protocol_request_fields_ok_cb),
 	                      _("Cancel"),
diff --git a/libpurple/protocols/facebook/util.c b/libpurple/protocols/facebook/util.c
--- a/libpurple/protocols/facebook/util.c
+++ b/libpurple/protocols/facebook/util.c
@@ -295,8 +295,7 @@ fb_util_rand_alnum(guint len)
 }
 
 static void
-fb_util_request_buddy_ok(gpointer *request_data, PurpleRequestFields *fields)
-{
+fb_util_request_buddy_ok(gpointer *request_data, PurpleRequestPage *page) {
 	FbUtilRequestBuddyFunc func = request_data[0];
 	GList *l;
 	GList *select;
@@ -310,7 +309,7 @@ fb_util_request_buddy_ok(gpointer *reque
 		return;
 	}
 
-	field = purple_request_fields_get_field(fields, "buddy");
+	field = purple_request_page_get_field(page, "buddy");
 	select = purple_request_field_list_get_selected(field);
 
 	for (l = select; l != NULL; l = l->next) {
@@ -327,7 +326,7 @@ fb_util_request_buddy_ok(gpointer *reque
 
 static void
 fb_util_request_buddy_cancel(gpointer *request_data,
-                             G_GNUC_UNUSED PurpleRequestFields *fields)
+                             G_GNUC_UNUSED PurpleRequestPage *page)
 {
 	FbUtilRequestBuddyFunc func = request_data[1];
 	gpointer data = request_data[2];
@@ -382,7 +381,7 @@ fb_util_request_buddy(PurpleConnection *
 	PurpleRequestCommonParameters *cpar;
 	PurpleRequestField *field;
 	PurpleRequestGroup *group;
-	PurpleRequestFields *fields;
+	PurpleRequestPage *page;
 
 	request_data = g_new0(gpointer, 3);
 	request_data[0] = ok_cb;
@@ -393,9 +392,9 @@ fb_util_request_buddy(PurpleConnection *
 	buddies = purple_blist_find_buddies(acct, NULL);
 	buddies = g_slist_sort(buddies, fb_buddy_cmp);
 
-	fields = purple_request_fields_new();
+	page = purple_request_page_new();
 	group = purple_request_group_new(NULL);
-	purple_request_fields_add_group(fields, group);
+	purple_request_page_add_group(page, group);
 
 	field = purple_request_field_list_new("buddy", NULL);
 	purple_request_field_list_set_multi_select(field, multi);
@@ -422,7 +421,7 @@ fb_util_request_buddy(PurpleConnection *
 	g_list_free_full(items, g_free);
 
 	cpar = purple_request_cpar_from_connection(gc);
-	return purple_request_fields(gc, title, primary, secondary, fields,
+	return purple_request_fields(gc, title, primary, secondary, page,
 	                             _("Ok"),
 	                             G_CALLBACK(fb_util_request_buddy_ok),
 				     _("Cancel"),
diff --git a/libpurple/protocols/gg/multilogon.c b/libpurple/protocols/gg/multilogon.c
--- a/libpurple/protocols/gg/multilogon.c
+++ b/libpurple/protocols/gg/multilogon.c
@@ -217,7 +217,7 @@ ggp_multilogon_dialog(PurpleConnection *
 {
 	ggp_multilogon_session_data *mldata = ggp_multilogon_get_mldata(gc);
 	PurpleRequestField *field;
-	PurpleRequestFields *fields;
+	PurpleRequestPage *page;
 	PurpleRequestGroup *group;
 	PurpleRequestCommonParameters *cpar;
 	PurpleRequestDatasheet *sheet;
@@ -227,9 +227,9 @@ ggp_multilogon_dialog(PurpleConnection *
 	if (mldata->dialog_handle != NULL)
 		return;
 
-	fields = purple_request_fields_new();
+	page = purple_request_page_new();
 	group = purple_request_group_new(NULL);
-	purple_request_fields_add_group(fields, group);
+	purple_request_page_add_group(page, group);
 
 	sheet = purple_request_datasheet_new();
 	purple_request_datasheet_add_column(sheet,
@@ -253,7 +253,7 @@ ggp_multilogon_dialog(PurpleConnection *
 	purple_request_cpar_set_icon(cpar, PURPLE_REQUEST_ICON_DIALOG);
 
 	dialog_handle = purple_request_fields(gc,
-		_("Other Gadu-Gadu sessions"), NULL, NULL, fields,
+		_("Other Gadu-Gadu sessions"), NULL, NULL, page,
 		NULL, NULL, _("Close"), NULL,
 		cpar, NULL);
 	mldata->sheet_handle = sheet;
diff --git a/libpurple/protocols/gg/pubdir-prpl.c b/libpurple/protocols/gg/pubdir-prpl.c
--- a/libpurple/protocols/gg/pubdir-prpl.c
+++ b/libpurple/protocols/gg/pubdir-prpl.c
@@ -727,16 +727,15 @@ ggp_pubdir_search_results_display(Purple
 }
 
 static void
-ggp_pubdir_search_request(PurpleConnection *gc, PurpleRequestFields *fields)
-{
+ggp_pubdir_search_request(PurpleConnection *gc, PurpleRequestPage *page) {
 	ggp_pubdir_search_form *form = g_new0(ggp_pubdir_search_form, 1);
 
 	purple_debug_info("gg", "ggp_pubdir_search_request");
 
-	form->nick = g_strdup(purple_request_fields_get_string(fields, "name"));
-	form->city = g_strdup(purple_request_fields_get_string(fields, "city"));
+	form->nick = g_strdup(purple_request_page_get_string(page, "name"));
+	form->city = g_strdup(purple_request_page_get_string(page, "city"));
 	form->gender =
-	        GPOINTER_TO_INT(purple_request_fields_get_choice(fields, "gender"));
+	        GPOINTER_TO_INT(purple_request_page_get_choice(page, "gender"));
 	form->offset = 0;
 	form->limit = GGP_PUBDIR_SEARCH_PER_PAGE;
 
@@ -747,15 +746,15 @@ ggp_pubdir_search_request(PurpleConnecti
 void
 ggp_pubdir_search(PurpleConnection *gc, const ggp_pubdir_search_form *form)
 {
-	PurpleRequestFields *fields;
+	PurpleRequestPage *page;
 	PurpleRequestGroup *group;
 	PurpleRequestField *field;
 
 	purple_debug_info("gg", "ggp_pubdir_search");
 
-	fields = purple_request_fields_new();
+	page = purple_request_page_new();
 	group = purple_request_group_new(NULL);
-	purple_request_fields_add_group(fields, group);
+	purple_request_page_add_group(page, group);
 
 	field = purple_request_field_string_new("name", _("Name"),
 	                                        form ? form->nick : NULL, FALSE);
@@ -775,7 +774,7 @@ ggp_pubdir_search(PurpleConnection *gc, 
 	purple_request_group_add_field(group, field);
 
 	purple_request_fields(gc, _("Find buddies"), _("Find buddies"),
-	                      _("Please, enter your search criteria below"), fields,
+	                      _("Please, enter your search criteria below"), page,
 	                      _("OK"), G_CALLBACK(ggp_pubdir_search_request),
 	                      _("Cancel"), NULL,
 	                      purple_request_cpar_from_connection(gc), gc);
@@ -892,7 +891,7 @@ static void ggp_pubdir_set_info_got_toke
 }
 
 static void
-ggp_pubdir_set_info_request(PurpleConnection *gc, PurpleRequestFields *fields)
+ggp_pubdir_set_info_request(PurpleConnection *gc, PurpleRequestPage *page)
 {
 	PurpleAccount *account = purple_connection_get_account(gc);
 	PurpleContactInfo *info = PURPLE_CONTACT_INFO(account);
@@ -904,24 +903,23 @@ ggp_pubdir_set_info_request(PurpleConnec
 	purple_debug_info("gg", "ggp_pubdir_set_info_request");
 
 	record->uin = uin;
-	record->first_name =
-	        g_strdup(purple_request_fields_get_string(fields, "first_name"));
-	record->last_name =
-	        g_strdup(purple_request_fields_get_string(fields, "last_name"));
-	record->gender =
-	        GPOINTER_TO_INT(purple_request_fields_get_choice(fields, "gender"));
-	record->city = g_strdup(purple_request_fields_get_string(fields, "city"));
-	record->province = GPOINTER_TO_INT(
-	        purple_request_fields_get_choice(fields, "province"));
+	record->first_name = g_strdup(purple_request_page_get_string(page,
+	                                                             "first_name"));
+	record->last_name = g_strdup(purple_request_page_get_string(page,
+	                                                            "last_name"));
+	record->gender = GPOINTER_TO_INT(purple_request_page_get_choice(page,
+	                                                                "gender"));
+	record->city = g_strdup(purple_request_page_get_string(page, "city"));
+	record->province = GPOINTER_TO_INT(purple_request_page_get_choice(page,
+	                                                                  "province"));
 
-	birth_s = g_strdup_printf(
-	        "%sT10:00:00+00:00",
-	        purple_request_fields_get_string(fields, "birth_date"));
+	birth_s = g_strdup_printf("%sT10:00:00+00:00",
+	                          purple_request_page_get_string(page, "birth_date"));
 	record->birth = g_date_time_new_from_iso8601(birth_s, NULL);
 	g_free(birth_s);
 	purple_debug_info("gg", "ggp_pubdir_set_info_request: birth [%lu][%s]",
 	                  g_date_time_to_unix(record->birth),
-	                  purple_request_fields_get_string(fields, "birth_date"));
+	                  purple_request_page_get_string(page, "birth_date"));
 
 	url = g_strdup_printf("http://api.gadu-gadu.pl/users/%u.xml", uin);
 	ggp_oauth_request(gc, ggp_pubdir_set_info_got_token, record, "PUT", url);
@@ -934,7 +932,7 @@ ggp_pubdir_set_info_dialog(PurpleConnect
                            G_GNUC_UNUSED int next_offset,
                            G_GNUC_UNUSED gpointer data)
 {
-	PurpleRequestFields *fields;
+	PurpleRequestPage *page;
 	PurpleRequestGroup *group;
 	PurpleRequestField *field;
 	gchar *bday = NULL;
@@ -946,9 +944,9 @@ ggp_pubdir_set_info_dialog(PurpleConnect
 
 	record = (records_count == 1 ? &records[0] : NULL);
 
-	fields = purple_request_fields_new();
+	page = purple_request_page_new();
 	group = purple_request_group_new(NULL);
-	purple_request_fields_add_group(fields, group);
+	purple_request_page_add_group(page, group);
 
 	field = purple_request_field_string_new("first_name", _("First name"),
 	                                        record ? record->first_name : NULL,
@@ -1005,7 +1003,7 @@ ggp_pubdir_set_info_dialog(PurpleConnect
 	}
 
 	purple_request_fields(gc, _("Set User Info"), _("Set User Info"), NULL,
-	                      fields, _("OK"),
+	                      page, _("OK"),
 	                      G_CALLBACK(ggp_pubdir_set_info_request), _("Cancel"),
 	                      NULL, purple_request_cpar_from_connection(gc), gc);
 }
diff --git a/libpurple/protocols/gg/status.c b/libpurple/protocols/gg/status.c
--- a/libpurple/protocols/gg/status.c
+++ b/libpurple/protocols/gg/status.c
@@ -204,11 +204,6 @@ const gchar * ggp_status_get_name(const 
  * Own status.
  ******************************************************************************/
 
-static void ggp_status_broadcasting_dialog_ok(PurpleConnection *gc,
-	PurpleRequestFields *fields);
-
-/******************************************************************************/
-
 void ggp_status_set_initial(PurpleConnection *gc, struct gg_login_params *glp)
 {
 	ggp_status_session_data *ssdata = ggp_status_get_ssdata(gc);
@@ -339,15 +334,23 @@ void ggp_status_set_status_broadcasting(
 		purple_account_get_active_status(account));
 }
 
+static void
+ggp_status_broadcasting_dialog_ok(PurpleConnection *gc,
+                                  PurpleRequestPage *page)
+{
+	gboolean buddies_only = purple_request_page_get_bool(page, "buddies_only");
+	ggp_status_set_status_broadcasting(gc, !buddies_only);
+}
+
 void ggp_status_broadcasting_dialog(PurpleConnection *gc)
 {
-	PurpleRequestFields *fields;
+	PurpleRequestPage *page;
 	PurpleRequestGroup *group;
 	PurpleRequestField *field;
 
-	fields = purple_request_fields_new();
+	page = purple_request_page_new();
 	group = purple_request_group_new(NULL);
-	purple_request_fields_add_group(fields, group);
+	purple_request_page_add_group(page, group);
 
 	field = purple_request_field_bool_new("buddies_only",
 		_("Show status only for buddies"),
@@ -358,19 +361,12 @@ void ggp_status_broadcasting_dialog(Purp
 		_("Change status broadcasting"),
 		_("Please, select who can see your status"),
 		NULL,
-		fields,
+		page,
 		_("OK"), G_CALLBACK(ggp_status_broadcasting_dialog_ok),
 		_("Cancel"), NULL,
 		purple_request_cpar_from_connection(gc), gc);
 }
 
-static void ggp_status_broadcasting_dialog_ok(PurpleConnection *gc,
-	PurpleRequestFields *fields)
-{
-	ggp_status_set_status_broadcasting(gc,
-		!purple_request_fields_get_bool(fields, "buddies_only"));
-}
-
 /*******************************************************************************
  * Buddy status.
  ******************************************************************************/
diff --git a/libpurple/protocols/jabber/auth.c b/libpurple/protocols/jabber/auth.c
--- a/libpurple/protocols/jabber/auth.c
+++ b/libpurple/protocols/jabber/auth.c
@@ -74,8 +74,7 @@ static void disallow_plaintext_auth(Purp
 }
 
 static void
-auth_old_pass_cb(PurpleConnection *gc, PurpleRequestFields *fields)
-{
+auth_old_pass_cb(PurpleConnection *gc, PurpleRequestPage *page) {
 	PurpleAccount *account;
 	JabberStream *js;
 	const char *entry;
@@ -87,8 +86,8 @@ auth_old_pass_cb(PurpleConnection *gc, P
 	account = purple_connection_get_account(gc);
 	js = purple_connection_get_protocol_data(gc);
 
-	entry = purple_request_fields_get_string(fields, "password");
-	remember = purple_request_fields_get_bool(fields, "remember");
+	entry = purple_request_page_get_string(page, "password");
+	remember = purple_request_page_get_bool(page, "remember");
 
 	if (!entry || !*entry)
 	{
@@ -116,9 +115,7 @@ auth_old_pass_cb(PurpleConnection *gc, P
 }
 
 static void
-auth_no_pass_cb(PurpleConnection *gc,
-                G_GNUC_UNUSED PurpleRequestFields *fields)
-{
+auth_no_pass_cb(PurpleConnection *gc, G_GNUC_UNUSED PurpleRequestPage *page) {
 	/* TODO: the password prompt dialog doesn't get disposed if the account disconnects */
 	PURPLE_ASSERT_CONNECTION_IS_VALID(gc);
 
diff --git a/libpurple/protocols/jabber/buddy.c b/libpurple/protocols/jabber/buddy.c
--- a/libpurple/protocols/jabber/buddy.c
+++ b/libpurple/protocols/jabber/buddy.c
@@ -555,8 +555,7 @@ jabber_set_buddy_icon(G_GNUC_UNUSED Purp
  * Sets the vCard with data from PurpleRequestFields.
  */
 static void
-jabber_format_info(PurpleConnection *gc, PurpleRequestFields *fields)
-{
+jabber_format_info(PurpleConnection *gc, PurpleRequestPage *page) {
 	PurpleXmlNode *vc_node;
 	PurpleRequestField *field;
 	PurpleProtocol *protocol = NULL;
@@ -574,7 +573,7 @@ jabber_format_info(PurpleConnection *gc,
 		if (*vc_tp->label == '\0')
 			continue;
 
-		field = purple_request_fields_get_field(fields, vc_tp->tag);
+		field = purple_request_page_get_field(page, vc_tp->tag);
 		text  = purple_request_field_string_get_value(field);
 
 
@@ -619,7 +618,7 @@ jabber_setup_set_info(G_GNUC_UNUSED GSim
 	PurpleAccountManager *manager = NULL;
 	PurpleAccount *account = NULL;
 	PurpleConnection *connection = NULL;
-	PurpleRequestFields *fields;
+	PurpleRequestPage *page;
 	PurpleRequestGroup *group;
 	PurpleRequestField *field;
 	const struct vcard_template *vc_tp;
@@ -637,9 +636,9 @@ jabber_setup_set_info(G_GNUC_UNUSED GSim
 	account = purple_account_manager_find_by_id(manager, account_id);
 	connection = purple_account_get_connection(account);
 
-	fields = purple_request_fields_new();
+	page = purple_request_page_new();
 	group = purple_request_group_new(NULL);
-	purple_request_fields_add_group(fields, group);
+	purple_request_page_add_group(page, group);
 
 	/*
 	 * Get existing, XML-formatted, user info
@@ -691,7 +690,7 @@ jabber_setup_set_info(G_GNUC_UNUSED GSim
 	                      _("Edit XMPP vCard"),
 	                      _("All items below are optional. Enter only the "
 	                        "information with which you feel comfortable."),
-	                      fields,
+	                      page,
 	                      _("Save"), G_CALLBACK(jabber_format_info),
 	                      _("Cancel"), NULL,
 	                      purple_request_cpar_from_connection(connection),
diff --git a/libpurple/protocols/jabber/jabber.c b/libpurple/protocols/jabber/jabber.c
--- a/libpurple/protocols/jabber/jabber.c
+++ b/libpurple/protocols/jabber/jabber.c
@@ -1861,15 +1861,14 @@ jabber_password_change_result_cb(JabberS
 	g_free(data);
 }
 
-static void jabber_password_change_cb(JabberStream *js,
-		PurpleRequestFields *fields)
-{
+static void
+jabber_password_change_cb(JabberStream *js, PurpleRequestPage *page) {
 	const char *p1, *p2;
 	JabberIq *iq;
 	PurpleXmlNode *query, *y;
 
-	p1 = purple_request_fields_get_string(fields, "password1");
-	p2 = purple_request_fields_get_string(fields, "password2");
+	p1 = purple_request_page_get_string(page, "password1");
+	p2 = purple_request_page_get_string(page, "password2");
 
 	if(!purple_strequal(p1, p2)) {
 		purple_notify_error(js->gc, NULL,
@@ -1903,7 +1902,7 @@ jabber_password_change(G_GNUC_UNUSED GSi
 	PurpleAccount *account = NULL;
 	PurpleConnection *connection = NULL;
 	JabberStream *js = NULL;
-	PurpleRequestFields *fields;
+	PurpleRequestPage *page;
 	PurpleRequestGroup *group;
 	PurpleRequestField *field;
 
@@ -1918,9 +1917,9 @@ jabber_password_change(G_GNUC_UNUSED GSi
 	connection = purple_account_get_connection(account);
 	js = purple_connection_get_protocol_data(connection);
 
-	fields = purple_request_fields_new();
+	page = purple_request_page_new();
 	group = purple_request_group_new(NULL);
-	purple_request_fields_add_group(fields, group);
+	purple_request_page_add_group(page, group);
 
 	field = purple_request_field_string_new("password1", _("Password"),
 			"", FALSE);
@@ -1937,7 +1936,7 @@ jabber_password_change(G_GNUC_UNUSED GSi
 	purple_request_fields(connection, _("Change XMPP Password"),
 	                      _("Change XMPP Password"),
 	                      _("Please enter your new password"),
-	                      fields,
+	                      page,
 	                      _("OK"), G_CALLBACK(jabber_password_change_cb),
 	                      _("Cancel"), NULL,
 	                      purple_request_cpar_from_connection(connection), js);
@@ -2613,17 +2612,15 @@ typedef struct {
 
 static void
 jabber_media_cancel_cb(JabberMediaRequest *request,
-                       G_GNUC_UNUSED PurpleRequestFields *fields)
+                       G_GNUC_UNUSED PurpleRequestPage *page)
 {
 	g_free(request->who);
 	g_free(request);
 }
 
 static void
-jabber_media_ok_cb(JabberMediaRequest *request, PurpleRequestFields *fields)
-{
-	PurpleRequestField *field =
-			purple_request_fields_get_field(fields, "resource");
+jabber_media_ok_cb(JabberMediaRequest *request, PurpleRequestPage *page) {
+	PurpleRequestField *field = purple_request_page_get_field(page, "resource");
 	const gchar *selected = purple_request_field_choice_get_value(field);
 	gchar *who = g_strdup_printf("%s/%s", request->who, selected);
 	jabber_initiate_media(request->media, request->account, who, request->type);
@@ -2697,12 +2694,12 @@ jabber_initiate_media(PurpleProtocolMedi
 		 * we need to pick one to initiate with */
 		GList *l;
 		char *msg;
-		PurpleRequestFields *fields;
-		PurpleRequestField *field = purple_request_field_choice_new(
-				"resource", _("Resource"), 0);
-		PurpleRequestGroup *group;
+		PurpleRequestPage *page = NULL;
+		PurpleRequestField *field = NULL;
+		PurpleRequestGroup *group = NULL;
 		JabberMediaRequest *request;
 
+		field = purple_request_field_choice_new("resource", _("Resource"), 0);
 		for(l = jb->resources; l; l = l->next)
 		{
 			JabberBuddyResource *ljbr = l->data;
@@ -2750,7 +2747,7 @@ jabber_initiate_media(PurpleProtocolMedi
 		}
 
 		msg = g_strdup_printf(_("Please select the resource of %s with which you would like to start a media session."), who);
-		fields = purple_request_fields_new();
+		page = purple_request_page_new();
 		group =	purple_request_group_new(NULL);
 		request = g_new0(JabberMediaRequest, 1);
 		request->media = media;
@@ -2759,9 +2756,9 @@ jabber_initiate_media(PurpleProtocolMedi
 		request->type = type;
 
 		purple_request_group_add_field(group, field);
-		purple_request_fields_add_group(fields, group);
+		purple_request_page_add_group(page, group);
 		purple_request_fields(account, _("Select a Resource"), msg,
-				NULL, fields, _("Initiate Media"),
+				NULL, page, _("Initiate Media"),
 				G_CALLBACK(jabber_media_ok_cb), _("Cancel"),
 				G_CALLBACK(jabber_media_cancel_cb),
 				purple_request_cpar_from_account(account),
diff --git a/libpurple/protocols/jabber/si.c b/libpurple/protocols/jabber/si.c
--- a/libpurple/protocols/jabber/si.c
+++ b/libpurple/protocols/jabber/si.c
@@ -1469,7 +1469,7 @@ static void jabber_si_xfer_send_disco_cb
 
 static void
 resource_select_cancel_cb(PurpleXfer *xfer,
-                          G_GNUC_UNUSED PurpleRequestFields *fields)
+                          G_GNUC_UNUSED PurpleRequestPage *page)
 {
 	purple_xfer_cancel_local(xfer);
 }
@@ -1516,9 +1516,10 @@ static void do_transfer_send(PurpleXfer 
 	g_free(who);
 }
 
-static void resource_select_ok_cb(PurpleXfer *xfer, PurpleRequestFields *fields)
+static void
+resource_select_ok_cb(PurpleXfer *xfer, PurpleRequestPage *page)
 {
-	PurpleRequestField *field = purple_request_fields_get_field(fields, "resource");
+	PurpleRequestField *field = purple_request_page_get_field(page, "resource");
 	const char *selected_label = purple_request_field_choice_get_value(field);
 
 	do_transfer_send(xfer, selected_label);
@@ -1587,7 +1588,7 @@ static void jabber_si_xfer_xfer_init(Pur
 			/* we've got multiple resources, we need to pick one to send to */
 			GList *l;
 			char *msg = g_strdup_printf(_("Please select the resource of %s to which you would like to send a file"), purple_xfer_get_remote_user(xfer));
-			PurpleRequestFields *fields = purple_request_fields_new();
+			PurpleRequestPage *page = purple_request_page_new();
 			PurpleRequestField *field = purple_request_field_choice_new("resource", _("Resource"), 0);
 			PurpleRequestGroup *group = purple_request_group_new(NULL);
 
@@ -1598,9 +1599,9 @@ static void jabber_si_xfer_xfer_init(Pur
 
 			purple_request_group_add_field(group, field);
 
-			purple_request_fields_add_group(fields, group);
+			purple_request_page_add_group(page, group);
 
-			purple_request_fields(jsx->js->gc, _("Select a Resource"), msg, NULL, fields,
+			purple_request_fields(jsx->js->gc, _("Select a Resource"), msg, NULL, page,
 					_("Send File"), G_CALLBACK(resource_select_ok_cb), _("Cancel"), G_CALLBACK(resource_select_cancel_cb),
 					purple_request_cpar_from_connection(jsx->js->gc), xfer);
 
diff --git a/libpurple/protocols/jabber/xdata.c b/libpurple/protocols/jabber/xdata.c
--- a/libpurple/protocols/jabber/xdata.c
+++ b/libpurple/protocols/jabber/xdata.c
@@ -47,7 +47,8 @@ struct jabber_x_data_data {
 	PurpleRequestGroup *actiongroup;
 };
 
-static void jabber_x_data_ok_cb(struct jabber_x_data_data *data, PurpleRequestFields *fields) {
+static void
+jabber_x_data_ok_cb(struct jabber_x_data_data *data, PurpleRequestPage *page) {
 	PurpleXmlNode *result = purple_xmlnode_new("x");
 	GCallback cb = data->cb;
 	gpointer user_data = data->user_data;
@@ -59,7 +60,7 @@ static void jabber_x_data_ok_cb(struct j
 	purple_xmlnode_set_namespace(result, "jabber:x:data");
 	purple_xmlnode_set_attrib(result, "type", "submit");
 
-	for(groups = purple_request_fields_get_groups(fields); groups; groups = groups->next) {
+	for(groups = purple_request_page_get_groups(page); groups; groups = groups->next) {
 		if(groups->data == data->actiongroup) {
 			for(flds = purple_request_group_get_fields(groups->data); flds; flds = flds->next) {
 				PurpleRequestField *field = flds->data;
@@ -157,7 +158,7 @@ static void jabber_x_data_ok_cb(struct j
 
 static void
 jabber_x_data_cancel_cb(struct jabber_x_data_data *data,
-                        G_GNUC_UNUSED PurpleRequestFields *fields)
+                        G_GNUC_UNUSED PurpleRequestPage *page)
 {
 	PurpleXmlNode *result = purple_xmlnode_new("x");
 	GCallback cb = data->cb;
@@ -190,7 +191,7 @@ void *jabber_x_data_request_with_actions
 {
 	void *handle;
 	PurpleXmlNode *fn, *x;
-	PurpleRequestFields *fields;
+	PurpleRequestPage *page;
 	PurpleRequestGroup *group;
 	PurpleRequestField *field = NULL;
 
@@ -204,9 +205,9 @@ void *jabber_x_data_request_with_actions
 	data->cb = G_CALLBACK(cb);
 	data->js = js;
 
-	fields = purple_request_fields_new();
+	page = purple_request_page_new();
 	group = purple_request_group_new(NULL);
-	purple_request_fields_add_group(fields, group);
+	purple_request_page_add_group(page, group);
 
 	for(fn = purple_xmlnode_get_child(packet, "field"); fn; fn = purple_xmlnode_get_next_twin(fn)) {
 		PurpleXmlNode *valuenode;
@@ -366,7 +367,7 @@ void *jabber_x_data_request_with_actions
 		int i;
 
 		data->actiongroup = group = purple_request_group_new(_("Actions"));
-		purple_request_fields_add_group(fields, group);
+		purple_request_page_add_group(page, group);
 		actionfield = purple_request_field_choice_new("libpurple:jabber:xdata:actions", _("Select an action"), GINT_TO_POINTER(defaultaction));
 
 		for(i = 0, action = actions; action; action = g_list_next(action), i++) {
@@ -385,7 +386,7 @@ void *jabber_x_data_request_with_actions
 	if((x = purple_xmlnode_get_child(packet, "instructions")))
 		instructions = purple_xmlnode_get_data(x);
 
-	handle = purple_request_fields(js->gc, title, title, instructions, fields,
+	handle = purple_request_fields(js->gc, title, title, instructions, page,
 			_("OK"), G_CALLBACK(jabber_x_data_ok_cb),
 			_("Cancel"), G_CALLBACK(jabber_x_data_cancel_cb),
 			purple_request_cpar_from_connection(js->gc),
